#include <stdio.h> 
#include <stdlib.h>
#include <math.h> 
int sgn(double x){
	if (x > 0) return 1;
	if (x < 0) return -1;
	return 0;
}
int main() {
	double v[1000][3],fa[1000][3],fb[1000][3],x[1000][3];
	double av[3],sv[3],dx[3];
	double wkb,avo,sigma,e,wm,cell,tset,dt,time0,t;
	double etot,ekin,epot,u;
	double sv2,av2,cellh,aa;
	double fdx[3];
	double rc,r2,rc2,d2,rd2,rd6,rd12,fk;
	int i,j,k,l,npart,nstep;

	FILE *fp1,*fp2,*fp3;
	fp1 = fopen("xe_ini_256.d", "r"); 
	fp2 = fopen("xe_moni_256.d", "w"); 
	fp3 = fopen("xe_out_256.d", "w"); 

	wkb = 1.38065812e-23;
	avo = 6.02213673e+23;
	
/* read initial data */
	fscanf(fp1,"%ld %ld %le %le %le %le %le %le",&npart,&nstep,&sigma,&e,&wm,&cell,&tset,&dt);
	npart = 256;
	for(i=0; i<npart; i++){
		fscanf(fp1, "%le %le %le", &x[i][0],&x[i][1],&x[i][2]);
		fscanf(fp1, "%le %le %le", &v[i][0],&v[i][1],&v[i][2]);
	}
	fscanf(fp1, "%le", &time0);
	fclose(fp1); 

	rc = 3.0e0 * sigma;
	r2 = sigma * sigma;
	rc2 = rc * rc;
	cellh = cell * 0.5e0;

/* remove momentum of the cell */
	for(l=0; l<3; l++){
		sv[l]=0.e0;
	}
	for(i = 0; i < npart; i++){
		for(l = 0; l < 3; l++){
			sv[l] += v[i][l];
		}
	}
	for(l = 0; l < 3; l++){
		av[l] = sv[l] / npart;
	}
	for(i = 0; i < npart; i++){
		for(l = 0; l < 3; l++){
			v[i][l] -= av[l];
		}
	}

/* force */
	u = 0.0e0;
	for(i = 0; i < npart; i++){
		for(l = 0; l < 3; l++){
			fb[i][l] = 0.0e0;
		}
	}
	for(i = 0; i < npart-1; i++){
		for(j = i+1; j < npart; j++){
			for(l = 0; l < 3; l++){
		    	dx[l] = x[i][l] - x[j][l];
				if(fabs(dx[l]) > cellh){
					dx[l] -= sgn(dx[l])*cell;
				}
			}
			d2 = dx[0] * dx[0] + dx[1] * dx[1] + dx[2] * dx[2];
		    if(d2 < rc2) {
				rd2 = r2 / d2;
				rd6 = rd2 * rd2 * rd2;
				rd12 = rd6 * rd6;
				fk = 48 * e * (rd12 - rd6 * 0.5e0);
				for(l = 0; l < 3; l++){
					fdx[l] = fk * dx[l] / d2;
					fb[i][l] += fdx[l];
					fb[j][l] -= fdx[l];
				}
				u += 4 * e * (rd12 - rd6);
			}
		}
	}

/* main loop */
	for(k = 0; k < nstep; k++){
		time0 = dt + time0;
/* update position and velocity */
		for(i = 0; i < npart; i++){
			for(l = 0; l < 3; l++){
				v[i][l] += dt * fb[i][l] / (2.e0 * wm);
				x[i][l] += dt * v[i][l];
			}
		}
/* periodic boundary condition */
		for(i = 0; i < npart; i++){
			for(l = 0; l < 3; l++){
				dx[l] = x[i][l]-cellh;
				if(fabs(dx[l]) > cellh){
					x[i][l] -= sgn(dx[l]) * cell;
				}
			}
		}
/* force */
	u = 0.e0;
	for(i = 0; i < npart; i++){
		for(l = 0; l < 3; l++){
			fa[i][l] = 0.e0;
		}
	}
	for(i = 0; i < npart-1; i++){
		for(j = i+1; j < npart; j++){
			for(l = 0; l < 3; l++){
		    	dx[l] = x[i][l] - x[j][l];
				if(fabs(dx[l]) > cellh){
					dx[l] -= sgn(dx[l]) * cell;
				}
			}
			d2 = dx[0] * dx[0] + dx[1] * dx[1] + dx[2] * dx[2];
		    if(d2 < rc2) {
				rd2 = r2 / d2;
				rd6 = rd2 * rd2 * rd2;
				rd12 = rd6 * rd6;
				fk = 48 * e * (rd12 - rd6 * 0.5e0);
				for(l = 0; l < 3; l++){
					fdx[l] = fk * dx[l] / d2;
					fa[i][l] += fdx[l];
					fa[j][l] -= fdx[l];
				}
				u += 4 * e * (rd12 - rd6);
			}
		}
	}
/* update velocity */
		for(i = 0; i < npart; i++){
			for(l = 0; l < 3; l++){
				v[i][l] += dt*fa[i][l]/(2.e0*wm);
				fb[i][l] = fa[i][l];
			}
		}
/* summation of the velocities */
		sv2=0.e0;
		for(i = 0; i < npart; i++){
			sv2 += v[i][0] * v[i][0] + v[i][1] * v[i][1] + v[i][2] * v[i][2];
		}
		av2 = sv2 / npart;
		t = wm * av2 / (3.e0 * wkb);
/* calculation of the total energy */
		epot = u * avo / npart;
		ekin = av2 * wm / 2.e0 * avo;
		etot = epot + ekin;
/* monitor */
	    fprintf(fp2, "%le %le %le %le %le\n", time0,ekin,epot,etot,t);
		printf("Ek ,Ep, E( %d )= %le %le %le \n", k,ekin,epot,etot);
		printf("time= %le   T= %f \n", time0,t);
	}
/* output */
	fprintf(fp3, "%ld %ld %le %le %le %le %le %le\n", npart,nstep,sigma,e,wm,cell,tset,dt);
	for(i = 0; i < npart; i++){
		fprintf(fp3, "%le %le %le\n", x[i][0],x[i][1],x[i][2]);
		fprintf(fp3, "%le %le %le\n", v[i][0],v[i][1],v[i][2]);
	}
	fprintf(fp3, "%le\n", time0);
	fclose(fp2);
	fclose(fp3);
	return 0;
}
